activities/urls.py
from django.urls import include, path

from activities.views import (
    ActivityDetailsView,
    ActivityEnrollmentSuccessView,
    ActivityUnrollmentSuccessView,
    IndexView,
    enroll,
    unroll,
)

app_name = "activities"

urlpatterns = [
    path("", IndexView.as_view(), name="index"),
    path("<int:pk>", ActivityDetailsView.as_view(), name="detail"),
    path("inschrijvingen/<int:admittanceID>/inschrijven", enroll, name="enroll"),
    path(
        "inschrijvingen/<int:pk>/inschrijving_gelukt",
        ActivityEnrollmentSuccessView.as_view(),
        name="enroll_success",
    ),
    path("inschrijvingen/<int:admittanceID>/uitschrijven", unroll, name="unroll"),
    path(
        "inschrijvingen/<int:pk>/uitschrijving_gelukt",
        ActivityUnrollmentSuccessView.as_view(),
        name="unroll_success",
    ),
]

news/urls.py
from django.urls import path

from . import views

app_name = "news"
urlpatterns = [
    path("", views.NewsListView.as_view(), name="news_list"),
    path("<int:pk>/", views.NewsDetailView.as_view(), name="news_detail"),
]

unchained/urls.py
from django.conf import settings
from django.conf.urls.static import static
from django.contrib import admin
from django.urls import include, path, re_path
from django.views.generic import RedirectView, TemplateView

from wrinklypages import views as wpviews

from . import views

urlpatterns = [
    path("", RedirectView.as_view(pattern_name="home")),
    path("home/", views.index, name="home"),
    path("admin/doc/", include("django.contrib.admindocs.urls")),
    path("admin/", admin.site.urls),
    path("activiteiten/", include("activities.urls")),
    path("service/docuweb/", include("docuweb.urls")),
    path("pages/", include("django.contrib.flatpages.urls")),
    path("leden/", include("members.urls")),
    path("vereniging/nieuws/", include("news.urls")),
    path("accounts/", include("authentication.urls")),
    path("vereniging/commissies/", include("groups.urls")),
    path("achievements/", include("achievements.urls")),
    path("i18n/", include("django.conf.urls.i18n")),
    path("ideal/", include("ideal.urls")),
    path("carriere/", include("career.urls")),
    path("publisher/", include("wrinklypages.urls")),
    path("tinymce/", include("tinymce.urls")),
    path("__debug__/", include("debug_toolbar.urls")),
] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

activities/models.py
from django.db import models

from .models.activity import Activity, ActivityCategory
from .models.admittance import Admittance
from .models.event import Event
from .models.ticket import Answer, Question, Ticket

activities/models/activity.py
from django.db import models

from groups.models import Group
from unchained.junk_drawer import enum_field
from unchained.types.queryset import QueryType


class ActivityCategory(models.Model):
    """A group of activities, for easier searchability."""

    title: str = models.CharField(max_length=256)

    def __str__(self) -> str:
        return self.title


class Activity(models.Model):
    """Activities group events, which members can attend.

    An activity has one description and one set of organisers.
    It has also some events, which indicate a time span and location.
    """

    title: str = models.CharField(max_length=1024)
    description: str = models.TextField()
    activity_poster = models.ImageField(
        upload_to="posters/activities/", null=True, blank=True
    )
    organisers: QueryType[Group] = models.ManyToManyField("groups.Group")
    categories: QueryType[ActivityCategory] = models.ManyToManyField("ActivityCategory")

    def __str__(self) -> str:
        return self.title

activities/models/admittance.py
from decimal import Decimal

from django.db import models
from django.utils import timezone

from .event import Event


class Admittance(models.Model):
    """Indicates how people can register for an Event.

    Upon registration, a Ticket is generated,
    recording the enrollment.
    """

    event: Event = models.ForeignKey(Event, on_delete=models.CASCADE)

    # Maximum price is €999.99
    price: Decimal = models.DecimalField(max_digits=5, decimal_places=2)

    # Registration is the creation of a Ticket; deregistration the deletion.
    # If this field is set to a value before the current time,
    # registration is not possible, and similar for deregistration.
    # The deadlines are useful for the organisers to know who is coming.
    # These are simply limits for activity's visitors,
    # the organisers and board can still create a Ticket.
    # TODO: what happens if a user starts an iDeal transaction before the deadline,
    # and finishes it after the deadline? Is the iDeal timeout short enough?
    registration_deadline: timezone = models.DateTimeField(blank=True, null=True)
    deregistration_deadline: timezone = models.DateTimeField(blank=True, null=True)

    max_tickets: int = models.IntegerField(blank=True, null=True)

    def __str__(self) -> str:
        return f"Admittance '{self.event}' €{self.price}"

    class Meta:
        ordering = ["-registration_deadline", "-deregistration_deadline"]

activities/models/event.py
import datetime

from django.db import models

from .activity import Activity


class Event(models.Model):
    """Space-time coordinates associated to an Activity.

    An Activity can have multiple Events associated to it.
    This feature allows for repeating activities,
    such as, famously, the Working Party for the WebCie,
    number 153 of which this comment was written as.
    """

    # Why this structure of Activity 1 <- n Event?
    # In WhosWho, there were a few attempts at the correct representation.

    # There is one class Activiteit,
    # functioning both as Activity and Event.
    # An activity can repeat either daily, weekly or monthly,
    # and all these events are stored in one Activity object.
    # The issue with this is that finding the events on a given moment
    # is going to be very complicated.

    # Another attempt:
    # There is one class Activiteit,
    # functioning both as Activity and Event.
    # If an activity occurs $n$ times,
    # all information is entered in $n$ different Activiteit objects,
    # each with different time, and the last $n-1$ have the first Activiteit
    # as "repetition parent".
    # The issue with this is keeping track of changes,
    # e.g. when the second event changes, should the first and third change too?
    # And what if the change is a different starting time?

    # Another attempt:
    # There is a parent class Activiteit with children
    # ActiviteitInformatie and ActiviteitHerhaling.
    # These loosely correspond to Activity and Event respectively,
    # where ActiviteitInformatie also represented the first Event
    # and ActiviteitHerhaling for all following ones.
    # Having ActiviteitInformatie be special in this way was confusing.
    # Having one class for description and one for time should be easier.

    # So here is yet another attempt!

    activity: Activity = models.ForeignKey(Activity, on_delete=models.CASCADE)

    subtitle: str = models.CharField(max_length=1024)
    description: str = models.TextField(blank=True, null=True)
    event_poster = models.ImageField(upload_to="posters/events/", null=True, blank=True)
    location: str = models.TextField(blank=True, null=True)
    time_start: datetime = models.DateTimeField()
    time_end: datetime = models.DateTimeField()

    def __str__(self) -> str:
        return self.activity.title + ": " + self.subtitle

    def get_poster(self):
        return self.event_poster or self.activity.activity_poster

    class Meta:
        ordering = ["-time_start", "-time_end"]

achievements/views/detailviews.py
from django.contrib.auth.mixins import LoginRequiredMixin
from django.views import generic

from achievements.rewarding.achievement_utilities import person_has_achievement
from members.models.person import Person

from ..models import Achieved, Achievement, Medal, Received


class AchievementDetailView(LoginRequiredMixin, generic.DetailView):
    """
    this page shows in detail information about a specific achievement

    **authorised user only**

    **CONTEXT:**

        ``user_sees_achievement``
            bool which determines whether or not the current user has the rights to see this achievement

        ``achiever-list``
            a list of all people who have achieved this achievement

        ``num_visits``
            the number of times the current session has visited this specific achievement page in a row
            used for bad achievement lookup surprise

    **SESSION_DATA:**

        ``ACHIEVEMENTS_last_visited_achievement``
            abbrev field of the last visited achievement page,
            used to check if the current page is the same as the last page visited (used for surprise)

        ``ACHIEVEMENTS_num_visits``
            int telling how many times in a row this page has been visited by the current session

    **TEMPLATES:**

        :template:`../achievements/templates/achievements/achievement_detail.html`
    """

    model = Achievement

    slug_field = "abbrev"
    slug_url_kwarg = "name"

    def get_context_data(self, **kwargs):
        if (
            self.request.session.get("ACHIEVEMENTS_last_visited_achievement", "")
            == self.object.abbrev
        ):
            num_visits = self.request.session.get("ACHIEVEMENTS_num_visits", 0) + 1
        else:
            num_visits = 1
        self.request.session[
            "ACHIEVEMENTS_last_visited_achievement"
        ] = self.object.abbrev
        self.request.session["ACHIEVEMENTS_num_visits"] = num_visits
        user = self.request.user
        user_sees_achievement = (
            self.object.hidden
            or user.has_perm("achievements.can_see_all")
            or person_has_achievement(user.person, self.object)
        )

        context = super(AchievementDetailView, self).get_context_data(**kwargs)
        context["user_sees_achievement"] = user_sees_achievement
        context["achiever_list"] = Achieved.objects.filter(
            achievement=self.object
        ).filter(has_achieved=True)
        context["num_visits"] = num_visits
        # NOTE:
        #       type(user_sees_achievement)==Boolean
        #       type(achiever_list)==Queryset
        #       type(num_visits)==Integer
        return context


class MedalDetailView(LoginRequiredMixin, generic.DetailView):
    """
    This page shows detailed information about this :model:`achievements.medal`

    **authorised user only**

    **CONTEXT:**

        ``bronze_receiver_list``
            A list\* of all people who have the bronze rank in this medal

        ``silver_receiver_list``
            A list\* of all people who have the silver rank in this medal

        ``gold_receiver_list``
            A list\* of all people who have the gold rank in this medal

        ``platinum_receiver_list``
            A list\* of all people who have the platinum rank in this medal

        \* actually a queryset, but who cares amirite?
    **TEMPLATES:**
        :template:`../achievements/templates/achievements/medal_detail.html
    """

    model = Medal

    slug_field = "abbrev"
    slug_url_kwarg = "name"

    def get_context_data(self, *args, **kwargs):
        context = super(MedalDetailView, self).get_context_data(*args, **kwargs)
        context["bronze_receiver_list"] = Received.objects.filter(
            medal=self.object
        ).filter(rank__gte=1)
        context["silver_receiver_list"] = Received.objects.filter(
            medal=self.object
        ).filter(rank__gte=2)
        context["gold_receiver_list"] = Received.objects.filter(
            medal=self.object
        ).filter(rank__gte=3)
        context["platinum_receiver_list"] = Received.objects.filter(
            medal=self.object
        ).filter(rank__gte=4)
        return context

activities/views.py
from django.contrib.auth.decorators import login_required
from django.contrib.auth.mixins import LoginRequiredMixin
from django.db import transaction
from django.http import Http404, HttpResponseRedirect
from django.shortcuts import get_object_or_404
from django.urls import reverse
from django.utils import timezone
from django.views import View
from django.views.generic import DetailView, ListView, TemplateView
from django.views.generic.edit import FormView

from activities.models.activity import Activity
from activities.models.admittance import Admittance
from activities.models.ticket import Ticket
from ideal.models import Transaction


class IndexView(LoginRequiredMixin, ListView):
    template_name = "activities/index.html"
    context_object_name = "activity_list"

    def get_queryset(self):
        """Returns all activities"""
        return Activity.objects.all()


class ActivityDetailsView(LoginRequiredMixin, DetailView):
    model = Activity
    template_name = "activities/detail.html"
    context_object_name = "activity"

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        contact = self.request.user.person.contact
        context["events"] = []
        for event in context["activity"].event_set.all():
            admittances = []
            for admittance in event.admittance_set.all():
                admittances.append(
                    (
                        admittance,
                        can_enroll(admittance, contact),
                        can_unroll(admittance, contact),
                    )
                )
            context["events"].append((event, admittances))
        return context


class ActivityEnrollmentSuccessView(LoginRequiredMixin, DetailView):
    model = Admittance
    template_name = "activities/enroll_success.html"
    context_object_name = "admittance"


class ActivityUnrollmentSuccessView(LoginRequiredMixin, DetailView):
    model = Admittance
    template_name = "activities/unroll_success.html"
    context_object_name = "admittance"


@login_required
def enroll(request, admittanceID):
    """Given an admittance, enroll into the admittance with a ticket."""

    admittance = get_object_or_404(Admittance, pk=admittanceID)
    contact = request.user.person.contact

    if can_enroll(admittance, contact):
        # TODO: Fix transactions using iDeal.
        with transaction.atomic():
            transaction_object = Transaction.objects.create(buyer=contact)

            ticket = Ticket.objects.create(
                admittance=admittance,
                participant=request.user.person.contact,
                purchase=transaction_object,
                moment_registration=timezone.now(),
            )
            ticket.save()

        return HttpResponseRedirect(
            reverse("activities:enroll_success", args=(admittanceID,))
        )

    raise Http404("Deze activiteit bestaat niet of is niet inschrijfbaar.")


@login_required
def unroll(request, admittanceID):
    """Given an admittance, unroll out of the admittance."""

    admittance = get_object_or_404(Admittance, pk=admittanceID)
    contact = request.user.person.contact

    if can_unroll(admittance, contact):
        tickets = Ticket.objects.filter(admittance=admittance, participant=contact)
        for ticket in tickets:
            ticket.delete()

        return HttpResponseRedirect(
            reverse("activities:unroll_success", args=(admittanceID,))
        )

    raise Http404("Deze activiteit bestaat niet of is niet uitschrijfbaar.")


def is_user_registered(admittance, contact):
    return Ticket.objects.filter(admittance=admittance, participant=contact).exists()


def can_enroll(admittance, contact):
    # Check if the enrollment is on time, if the activity is not full and the user is not yet enrolled.
    ticketcount = len(Ticket.objects.filter(admittance=admittance))
    return (
        (
            admittance.registration_deadline is None
            or admittance.registration_deadline > timezone.now()
        )
        and (admittance.max_tickets is None or ticketcount < admittance.max_tickets)
        and (not is_user_registered(admittance, contact))
    )


def can_unroll(admittance, contact):
    # Check if the contact unrolls on time and if they are actually enrolled.
    return (
        admittance.deregistration_deadline is None
        or admittance.deregistration_deadline > timezone.now()
    ) and is_user_registered(admittance, contact)

activities/templates/activities/detail.html
{% extends "base.html" %}
{% load i18n %}

{% block title %}
Activiteit: {{ activity.title }}
{% endblock %}

{% block banner %}
    <h1 class="title"> {{ activity.title|capfirst }} </h1>
{% endblock %}

{% block body %}
<div class="columns" >
    <h2 class="subtitle column"> {{ activity.description }} </h2>

    <div class="activity-poster">
        {% if activity.activity_poster %}
            <img src="{{ activity.activity_poster.url }}">
        {% endif %}
        <div class="box" >
            <table class="table is-fullwidth is-striped">
                <tbody>
                    <tr>
                        <th> Organisator </th>
                    </tr>
                    <tr>
                        {% for organiser in activity.organisers.all %}
                            <td>{{ organiser }}</td> 
                        {% endfor %}
                    </tr>
                    <tr>
                        <th> Categorie </th>
                    </tr>
                    <tr>
                        {% for category in activity.categories.all %}
                            <td>{{ category }}</td>
                        {% endfor %}
                    </tr>
                    <th></th>
                    {% for event,_ in events %}
                        <tr>
                            <td>
                                <a href="#event-{{ event.pk }}">{{ event.subtitle }}</a>
                            </td>
                        </tr>
                    {% endfor %}
                </tbody>
            </table>
        </div>
    </div>
</div>

{% for event, admittance_set in events %}
<div class="box columns mt-0">
    <div class="column">
        <table class="table is-fullwidth is-striped">
            <tbody>
                <tr>
                    <th id="event-{{ event.id }}" class="is-size-4">{{ event.subtitle }}</th>
                </tr>
                <tr>
                    <td> {{ event.description }} </td>  
                </tr>
            </tbody>
        </table>
    </div>
    <div class="column is-one-third">
        <div>
            {% if event.get_poster %}
                <img class="event-poster" src="{{ event.get_poster.url }}">
            {% endif %}
        </div>
        <table class="table is-fullwidth is-striped">
            <tbody>
                <tr>
                    <th> Locatie </th>
                        <td>{{ event.location }}</td>     
                </tr>
                <tr>
                    <th> Begin </th>
                        <td>{{ event.time_start }}</td>     
                </tr>
                <tr>
                    <th> Eind </th>
                        <td>{{ event.time_end }}</td>     
                </tr>
            </tbody>
        </table>
        {% for admittance, enroll, unroll in admittance_set %}
            <table class="table is-fullwidth is-striped">
                <tbody>
                    <tr>
                        <th> Inschrijving </th>
                            <td>{{ admittance }}</td>         
                    </tr>
                    <tr>
                        <th> Prijs </th>
                            <td>€{{ admittance.price }}</td>     
                    </tr>
                    <tr>
                        <th> Inschrijfdeadline  </th>
                            <td>{{ admittance.registration_deadline }}</td>     
                    </tr>
                    <tr>
                        <th> Uitschrijfdeadline </th>
                            <td>{{ admittance.deregistration_deadline }}</td>     
                    </tr>
                    {% if enroll %}
                    <tr>
                        <th> Schrijf je in: </th>
                            <td><a href="{% url 'activities:enroll' admittance.pk %}"> Hier </a></td>    
                    </tr>
                    {% endif %} 
                    {% if unroll %}
                    <tr>
                        <th> Schrijf je uit: </th>
                            <td><a href="{% url 'activities:unroll' admittance.pk %}"> Hier </a></td>    
                    </tr>
                    {% endif %} 
                </tbody>
            </table>
        {% endfor %}
    </div>
</div>
{% endfor %}

{% endblock %}

activities/templates/activities/enroll_success.html
{% extends "base.html" %}

{% block body %}

<p>Je bent succesvol ingeschreven.</p>
<a href="{% url 'activities:detail' admittance.event.activity.pk %}">ga terug</a>

{% endblock %}

activities/templates/activities/index.html
{% extends "base.html" %}
{% load i18n %}

{% block title %}
    Activiteiten
{% endblock %}

{% block body %}
    <article>
        <ul>
            {% for activity in activity_list %}
                <li>
                    <section>
                        <h2>
                            <a href="{% url 'activities:detail' pk=activity.id %}">
                                {{ activity.title |capfirst }}
                            </a>
                            by 
                            {% for organiser in activity.organisers.all %}
                                {{ organiser }}
                            {% endfor %} 
                        </h2>
                    </section>    
                </li>       
            {% endfor %}
        </ul>
    </article>
{% endblock %}

activities/templates/activities/unroll_success.html
{% extends "base.html" %}

{% block body %}

<p>Je bent succesvol uitgeschreven.</p>
<a href="{% url 'activities:detail' admittance.event.activity.pk %}">ga terug</a>

{% endblock %}